static char *cvs_id =" $Id: bm2ph.c,v 1.1 2004/07/29 13:55:44 berar Exp $ ";
/*  xy2ph : image vers photon localises        */
/*  jfberar, flivet                            */
/* prevoir fenetre en energie ds la droplette  */
/* option sans frontiere, negatif autorise     */
/* ------------------------------------------- */
/*  4 nov 1998    correction release W95 .spe  */
/* 29 mar 2000    hpux  (.edf)                 */
/*  7 apr 2000    realtime : wait for open     */
/*  8 jan 2003    cvs, cygwin....              */


#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <errno.h>
#include <time.h>
#include <unistd.h>

/*-----------------------------------------------------------*/
#include "release.h"
#include "prg_def.h"
int   cr_mode = 0;

#if ( defined(DEF_XY_WV) || defined(INC_XY_WV) )
#include "wv_def.h"
#endif

#if ( defined(DEF_XY_GEL) || defined(INC_XY_GEL) )
#include "gel_def.h"
#endif

#if ( defined(DEF_XY_EDF ) || defined(INC_XY_EDF) )
#include "edf_def.h"
#endif
/*-----------------------------------------------------------*/

XY_MODE prg_xymode = NONE_XYMODE;

INT32    *dark;
INT16U   *val;
INT32    *res;
INT32    *gtt_sum = NULL;

XY_HDR   *dark_hdr;
XY_HDR   *data_hdr;
IMAGE     image;
/*-----------------------------------------------------------*/
typedef  struct
    {   int n_pixel;
        int n_xray;
        int mem_size;
        int sum;
        PIXEL *pixel;
        int   *xray;
        } DROPLET;
/*-----------------------------------------------------------*/
#define TITLE " extracting photons from"
#define REFERENCE "flivet and berar@esrf.fr (d2am), "

#define MAX_DROPLET 50000

/* default values */

/*-----------------------------------------------------------*/
/* declarations globales */
char     *prg_name;
FILE     *f_out;
DROPLET  *droplet;
int      max_droplet, n_droplet;
int      auto_peak = 0;
int      real_time = 0;

char     buffer[200], outbuffer[200];
int      e_min, e_max;
int      print_key = 0;
double   mean, sigma, c_mean;
time_t   start, act;
int      gtt_total;
int      gtt_frames;
/*-----------------------------------------------------------*/
int usage( char *name);
void parameter( FILE * f_ini);
int traite ( int trig_level );
int explore (long x, long y, DROPLET *droplet);
void print_droplet (int z_peak);
int histogramme(float moy);
int analyse(int z_peak, int max);
/*-----------------------------------------------------------*/
int usage( char *name)
{
    fprintf(stderr, "usage : %s [dark_file img_file [img...]]\n", prg_name );
    fprintf(stderr, "valid options in %s.ini files are : \n", name);
    fprintf(stderr, "  TRIG = set trig level, default is 4 times the dark sigma\n");
    fprintf(stderr, "  FIRST_DARK = first image\n");
    fprintf(stderr, "  LAST_DARK  = last image\n");
    fprintf(stderr, "  FIRST_IMG  = first image\n");
    fprintf(stderr, "  LAST_IMG   = last image\n");
    fprintf(stderr, "  ADD_DARK   = offset to add to dark curent\n");
    fprintf(stderr, "  PRINT_MAP  = relative scale for pixels to print\n");
    fprintf(stderr, "  PRINT_KEY  = 0/1 print all droplets, -1 avoid \n");
    fprintf(stderr, "  Z_PEAK     = if not automatic\n");
    fprintf(stderr, "  Z_TRIG     = if not .5\n");
    fprintf(stderr, "  Z_COSMIC   = if used ratio to z_peak\n");
    xy_iniuse();
    fprintf(stderr, "  DIR = full path to search for data file\n");
    fprintf(stderr, "  OUT = full path for result (.gtt) file\n");
    fprintf(stderr, "  MODE = sum or gtt, default sum : a 16bits tif \n");
    fprintf(stderr, "  REALTIME = 0  file must exist else wait at least REALTIME seconds before opening (integer)\n");
    if ( name && strlen(name)) fprintf (stderr, "%s\n", name);
    return 3;
    }
/*-----------------------------------------------------------*/
int   trig_level  = 0;
int   first_dark  = 0;
int   last_dark   = 0;
int   first_img   = 0;
int   last_img    = 0;
int   add_dark    = 0;

float    print_map = 0;
float    z_trig = 0.5;
float    z_cosmic  = 0.0;
char *dir = NULL;
char *outdir = NULL;
char *outmode = NULL;
enum { GTT, BIN, TIF, EDF } gtt_mode = GTT;
char *ext[] = {".", ".spe", ".edf"};

void parameter( FILE *f_ini)
{   char *d;
    char *tag, *arg;
    while (!feof(f_ini))
    {   fgets(buffer, sizeof(buffer)-1, f_ini);
        if (feof(f_ini)) break;
        d = buffer;
        while (*d == ' ' || *d == '\n' || *d == '\r') d++;
         if (*d=='#' || *d==0) continue;
        if ( prg_initag(d, &tag, &arg) == 0 ) continue;
        if ( xy_inipar(&image, tag, arg)) continue;
        if ( prg_iniint(tag, arg, "TRIG", &trig_level) ) continue;
        if ( prg_iniint(tag, arg, "FIRST_DARK", &first_dark) ) continue;
        if ( prg_iniint(tag, arg, "LAST_DARK", &last_dark) ) continue;
        if ( prg_iniint(tag, arg, "FIRST_IMG", &first_img) ) continue;
        if ( prg_iniint(tag, arg, "LAST_IMG", &last_img) ) continue;
        if ( prg_iniint(tag, arg, "ADD_DARK", &add_dark) ) continue;
        if ( prg_iniflt(tag, arg, "PRINT_MAP", &print_map) ) continue;
        if ( prg_iniint(tag, arg, "PRINT_KEY", &print_key) ) continue;
        if ( prg_iniint(tag, arg, "Z_PEAK", &auto_peak) ) continue;
        if ( prg_iniint(tag, arg, "REALTIME", &real_time) ) continue;
        if ( prg_iniflt(tag, arg, "Z_TRIG", &z_trig) ) continue;
        if ( prg_iniflt(tag, arg, "Z_COSMIC", &z_cosmic) ) continue;
        if ( prg_inistr(tag, arg, "DIR", &dir) ) continue;
        if ( prg_inistr(tag, arg, "OUT", &outdir) ) continue;
        if ( prg_inistr(tag, arg, "MODE", &outmode) ) continue;
       if (strstr(buffer, "P_EXCLUDED") != 0 )  excl_ini( 0, buffer );
       if (strstr(buffer, "C_EXCLUDED") != 0 )  excl_ini( 1, buffer );
       if (strstr(buffer, "R_EXCLUDED") != 0 )  excl_ini( 2, buffer );
       if (strstr(buffer, "T_EXCLUDED") != 0 )  excl_ini( 3, buffer );
        }
    }
/*-----------------------------------------------------------*/
int main ( int argc, char ** argv )
{
    char *c, name[100], bname[200], ename[20];
    enum { USE_ARGS, ASK_NAME } ask_mode;
	 double mean, sigma;
    long i, x, y;
    int  n, rep, repeat;
	 int  dont_cor, used; ADD_MERGE rep_mode;  /* not used, just for compatibility */
	 int df, iname;
    FILE * f_ini;
   
    prg_name = argv[0];
    argc--; argv++;
    prg_printf("## %s : %s\n## %s\n## %s %s\n", prg_name, TITLE, RELEASE, REFERENCE, __DATE__);
    xy_chktype();
    memset(&image, 0, sizeof(IMAGE));
	 c = strrchr(prg_name,'/');
	 if (c==NULL) c = strrchr(prg_name,'\\');
	 if (c==NULL) c = prg_name; else c++;
	 if ( strstr(c, "bm") == c ) prg_xymode = WV_XYMODE;
	 else if ( strstr(c, "wv") == c ) prg_xymode = WV_XYMODE;
	 else if ( strstr(c, "edf") == c ) prg_xymode = EDF_XYMODE;
    else 
	 {  fprintf(stderr," program name not recognized '%s' in '%s', expected are : bm2ph = ww2ph, edf2ph\n aborting\n", 
	          c, prg_name);
	    abort();
		 }
    max_droplet = MAX_DROPLET;
    prg_inifile( parameter );

    switch (argc)
    {  case 0 : ask_mode = ASK_NAME; break;
       case 1 : return usage(prg_name);
       default : ask_mode = USE_ARGS;
       }

	 do
    {  switch (ask_mode)
       {   case ASK_NAME :
             printf("\n dark file name (without '%s', return = exit) : ", ext[prg_xymode]);
             fgets(buffer, sizeof(buffer)-1, stdin);
	          name[0]=0;
             sscanf(buffer," %s", name);
             if (strlen(name)== 0) exit(1);
             break;
           case USE_ARGS : strcpy(name, *argv);
               argc--; argv++;
	     }
      image.beg_frame = first_dark;
      image.end_frame = last_dark;
		repeat = xy_rep_name( name, &image, bname, ename, 
		         &df, &iname, &dont_cor, &used, &rep_mode);
      image.name = name;
		for (rep = 0; rep < repeat; rep++, iname++)
		{  xy_cur_name(buffer, dir, bname, ename, df, iname);
         dark_hdr = xy_open(buffer, "bm2ph dark", 1, ext[prg_xymode], 0, 0);
         xy_puthdr( dark_hdr, 0);
         image.header = dark_hdr;
		   image.data = dark = xy_getsum( &image, stdout, print_key, rep==0, 0 );
		   xy_info(&image, 0);
         xy_fputinfo( stdout, &image);
         if (( repeat > 1) && (rep+1 != repeat)) xy_freehdr(dark_hdr);
         }
		/* mean background for one frame */	  
      if (image.used_frames > 1 )
		{  int dark_frames = image.used_frames / 2;
	      for (i=0; i<image.size; i++) dark[i] = (dark[i] + dark_frames)/image.used_frames;
	      for (i=0; i<image.size; i++) image.frame[i] = 1;  /* for correct mean calculation */
         image.used_frames = 1;
         printf( " normalising dark image to one frame\n");
			}
      if (add_dark)
      {  printf(" adding %d to all points in dark image\n", add_dark);
         for (i=0; i < image.size; i++) dark[i] += add_dark;
         }
      xy_info(&image, 0);
      xy_fputinfo( stdout, &image);
      res =  (INT32  *) malloc( image.size * sizeof(INT32));
      if (res==NULL) v_error(__FILE__," allocating memory : res %d",image.size * sizeof(INT32));
      image.t_data=T_INT32;
      image.data = res;
      do
      {  printf("\n image file name : ");
		    switch (ask_mode)
         {  case ASK_NAME :
               printf(" (return=modify dark) : ");
		         fgets(buffer, sizeof(buffer)-1, stdin);
		         name[0]=0;
               sscanf(buffer," %s", name);
               if (strlen(name)== 0) continue;
               break;
            case USE_ARGS : strcpy(name, *argv);
               printf(" %s\n", name);
               argc--; argv++;
	         }
         repeat = xy_rep_name( name, &image, bname, ename, 
		         &df, &iname, &dont_cor, &used, &rep_mode);
			if (ename) *ename=0;
		   xy_cur_name(outbuffer, outdir, bname, ename, df, iname);
			if (outmode == NULL || strstr(outmode,"sum") 
                 || strstr(outmode,"SUM") || strstr(outmode,"tif"))
		   {  strcat(outbuffer, ".tif");
            printf( " output of result in %s\n", outbuffer );
				gtt_mode = BIN;
				print_key = 0;
            f_out = fopen( outbuffer, "wb");
            if (f_out == NULL)
               v_error ( __FILE__, " unable to open result file '%s'\n", outbuffer);
				fclose(f_out);
				}
         else if (strstr(outmode,"gtt") || strstr(outmode,"GTT"))
		   {  strcat(outbuffer, ".gtt");
            printf( " output of result in %s\n", outbuffer );
				gtt_mode = GTT;
            f_out = fopen( outbuffer, "wb");
            if (f_out == NULL)
               v_error ( __FILE__, " unable to open result file '%s'\n", outbuffer);
            c = strstr(outbuffer, ".gtt"); if (c) *c=0;
				}
		   else  v_error ( __FILE__, " Unknown out_mode %s, must be gtt or sum");
         gtt_sum =  (INT32  *) malloc( image.size * sizeof(INT32));
         if (gtt_sum==NULL) v_error(__FILE__," allocating memory : sum %d",image.size * sizeof(INT32));
		   memset( gtt_sum, 0, sizeof(INT32)*image.size);
		   gtt_total = 0;
		   gtt_frames = 0;
		   image.name=name;
			for (rep = 0; rep < repeat; rep++, iname++)
		   {  xy_cur_name(buffer, dir, bname, ename, df, iname);
            data_hdr = xy_open(buffer, "bm2ph data", 1, ext[prg_xymode], real_time, 0);
            xy_puthdr( data_hdr, 0);
            if (xy_chkhdr(dark_hdr, data_hdr) == -1)
                v_error(__FILE__, "%s and %s are not compatible\n", dark_hdr->name, data_hdr->name);
            if(print_key > 0)
            {  fprintf(f_out, "#  dark = %s : %d frames used, mean %.1lf sigma %.1lf\n",
                   dark_hdr->name, image.used_frames, image.info.mean, image.info.sigma);
/*             for (i=0; i < n_excluded; i++)
                 fprintf( f_out, "# excluded circle x=%d y=%d r=%d\n",
                   excluded[i].x, excluded[i].y, excluded[i].z);
*/            }
            n = 0;
            time ( &start);
            while ( !feof( data_hdr->file) )
            { if ( ++n < first_img ) continue;
	           if ( last_img && n > last_img ) break;
              val = (INT16U  *) malloc( image.size * sizeof(INT16U));
              if (val==NULL) v_error(__FILE__, " allocating memory : val %d",image.size * sizeof(INT16U));
              switch (data_hdr->xy_mode)
				  {  case (WV_XYMODE ) : 
				        if ( wv_getraw( data_hdr, &image, val, n) == 0 ) continue;
				        break;
				     case (EDF_XYMODE ) : 
				        if ( edf_getraw( data_hdr, &image, val, n) == 0 ) continue;
				        break;
					  default :  v_error(__FILE__, "unhandled file mode %d for getraw\n", data_hdr->xy_mode);
                 }           
              mean = xy16u_mean(&image, val);
              sigma = xy16u_sigma(&image, val, mean);
              if (dark) for (i=0; i < image.size; i++)  res[i] = val[i]-dark[i];
              free(val);
              xy_info(&image, 8);
              printf( "\n '%s'  image %d  mean %.1lf (%.1lf) bg_cor %.1lf\n",
                 data_hdr->name, n, mean, sigma, image.info.mean);
              if (print_key > 0) fprintf( f_out, "#\n# '%s' image %d  mean %.1lf (%.1lf) bg_cor %.1lf\n", 
                 data_hdr->name, n, mean, sigma, image.info.mean);
              if (image.info.mean + trig_level < 0 )
                 v_error(__FILE__, "back ground is not properly corrected : %.1lf < -%d=-trig_level \n", image.info.mean, trig_level);
				  traite( trig_level );
				  gtt_frames++;
              }
			  if (data_hdr->file) {fclose(data_hdr->file); data_hdr->file=NULL;}	  
		     }  /* for rep */

		  {  image.data = gtt_sum;
		     image.name = outbuffer;
			  printf("\n\n %d photons have been located adding %d frames!\n", gtt_total, gtt_frames);
			  image.used_frames = 1;
           xy_info(&image, 0);
           xy_fputinfo( stdout, &image );
			  gel_write(&image, ".tif", 1);
		     image.data=res;
			  free(gtt_sum);
			  gtt_sum = NULL;
		     }
		  fclose(f_out);
        xy_freehdr(data_hdr);
        } while( (ask_mode == ASK_NAME && name[0])
                || ( ask_mode == USE_ARGS && argc != 0));
        xy_freehdr(dark_hdr);
        free(res);
        } while(ask_mode == ASK_NAME);
     return 1;
     }

/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
#define DROPLET_SIZE   10
#define DROPLET_NB   1000
int traite ( int trig_level )
{  long   i, x, y;
   int    z_peak, spix, max;
   int mem_droplet;
   DROPLET  *l_droplet;
   long sum;
   float moy;
   int n_rea, n_reap;

   n_rea = n_reap = 0;
   n_droplet = spix = 0;
   mem_droplet = DROPLET_NB;
   droplet = (DROPLET *) malloc(DROPLET_NB*sizeof(DROPLET));
   if ( droplet == NULL )
      v_error(__FILE__, " alloc DROPLET %d\n", mem_droplet);
   for (y=0; y<image.y_size; y++)
   for (x=0, i=y*image.x_size; x<image.x_size; x++, i++)      
   if (res[i] < trig_level ) continue;
   else 
   {  n_droplet++;
      if ( n_droplet >= mem_droplet)
      {  mem_droplet += DROPLET_NB;
         droplet = (DROPLET *) realloc(droplet, mem_droplet*sizeof(DROPLET));
         if ( droplet == NULL )
            v_error(__FILE__, " realloc DROPLET %d n_rea %d\n", mem_droplet, n_rea);
         n_rea++;
 	      }
      l_droplet = droplet + n_droplet -1;
      memset(l_droplet, 0, sizeof(DROPLET));
      l_droplet->pixel = (PIXEL *) malloc(DROPLET_SIZE*sizeof(PIXEL));
      if ( l_droplet->pixel == NULL )
         v_error(__FILE__, " pb realloc DROPLET-XYZ %d\n", droplet->mem_size);
      n_reap++;
		l_droplet->mem_size = DROPLET_SIZE;
      n_reap += explore(x, y, l_droplet);
      }
   if (n_droplet ==  0 )
   {  free(droplet);
      if (print_key > 0) fprintf(f_out, "# %d droplets (trig=%d)\n", n_droplet, trig_level);
	   printf(" %d droplets (trig=%d) ==>  0 photons", n_droplet, trig_level);
      if (gtt_sum==NULL) 
		{  if (print_key > 0) fprintf(f_out, "#X 0 photons\n");
         else fprintf(f_out, " 0\n", i) ;
			}
      return 0;
      }

    /* intercaler le traitement de toutes les goutelettes ici */
    sum = 0;
    max = 0;
    for ( i = 0, l_droplet = droplet; i < n_droplet; i++, l_droplet++)
    {  if ( l_droplet->sum > max ) max = l_droplet->sum;
       sum += l_droplet->sum;
       spix+= l_droplet->n_pixel;
       }
    moy = sum /(float) n_droplet;
    if (print_key > 0) fprintf(f_out, "# %d droplets with  %d pixels (trig=%d), z : mean=%.1f, max=%d\n", n_droplet, spix, trig_level,moy, max);
	 printf(" %d droplets with %d pixels (trig=%d), z : mean=%.1f, max=%d\n", n_droplet, spix, trig_level, moy, max);

    fflush(f_out);
    z_peak = histogramme( moy );
    if (print_key > 0) fprintf(f_out, "#Z %d peak\n", z_peak);
    fflush(f_out);
    
    if ( auto_peak == 0)
    {    i = analyse(z_peak, max);
         printf(" %d photons with z peak %d (z_trig=%.0f, z_cosmic=%.0f)\n", i, z_peak, z_peak*z_trig, z_peak*z_cosmic);
         if (print_key > 0) fprintf(f_out, "#X %d photons with z peak %d (z_trig=%.0f)\n", i, z_peak, z_peak*z_trig, z_peak*z_cosmic);
         else fprintf(f_out, " %d\n", i) ;
         }
    else 
    {    i = analyse(auto_peak, max);
         printf(" %d photons with z peak %d (z_trig=%.0f, z_cosmic=%.0f)\n", i, auto_peak, auto_peak*z_trig, auto_peak*z_cosmic);
         if (print_key > 0) fprintf(f_out, "#X %d photons with z peak %d (z_trig=%.0f)\n", i, auto_peak, auto_peak*z_trig, auto_peak*z_cosmic);
         else fprintf(f_out, " %d\n", i) ;
         }
    fflush(f_out);

    if (gtt_mode==GTT) print_droplet( z_peak );
	 for ( i = 0, l_droplet = droplet; i < n_droplet; i++, l_droplet++)
	 {	 PIXEL *l_pixel;
       int   j, *xray;
       gtt_total += l_droplet->n_xray;	
       l_pixel = l_droplet->pixel;
       for ( j=0, xray = l_droplet->xray; j < l_droplet->n_xray; j++, xray++)
               gtt_sum[l_pixel[*xray].x + l_pixel[*xray].y * image.x_size]++;
       }

    xy_info(&image, 0x1d);
    if ( image.info.nzero > 1 )
    {    image.info.mean *= image.size /image.info.nzero;
         image.info.sigma *= sqrt((image.size-1) / (image.info.nzero-1));
         }
    printf( " dark :  %d pixel, mean %.1lf (%.1lf) max %d  time %ds\n",
              image.info.nzero , image.info.mean, image.info.sigma, image.info.maxi, time(&act)-start);
    if (print_key > 0) fprintf(f_out, "# dark :  %d pixel, mean %.1lf (%.1lf) max %d time %ds\n",
              image.info.nzero , image.info.mean, image.info.sigma, image.info.maxi, time(&act)-start);
    /* nettoyage de la memoire */
    for (i=0; i<n_droplet; i++)  if (droplet[i].pixel)free(droplet[i].pixel);
    for (i=0; i<n_droplet; i++)  if (droplet[i].xray) free(droplet[i].xray);
    free(droplet);
    return n_droplet;     
    }
/*-----------------------------------------------------------*/
int explore (long x, long y, DROPLET *droplet)
{    long i;
	  int  n, z, rea;

     rea = 0;
     i = y * image.x_size + x;
     if ( res[i] == 0 ) return 0;
     n = droplet->n_pixel;
     if ( ++droplet->n_pixel >= droplet->mem_size )
     {   if ( n > max_droplet )
           v_error(__FILE__, " too much pixels (%d) in a droplet, percolating ???\n", max_droplet);
         droplet->mem_size += DROPLET_SIZE;
         droplet->pixel = (PIXEL *) realloc(droplet->pixel, droplet->mem_size*sizeof(PIXEL));
         rea++;
         if ( droplet->pixel == NULL )
           v_error(__FILE__, " pb realloc DROPLET->XYZ %d\n", droplet->mem_size);
         }
     droplet->pixel[n].x = x*image.x_obind+image.x_omin;
     droplet->pixel[n].y = y*image.y_obind+image.y_omin;
     droplet->pixel[n].z = z = res[i];
     if ( z < -50 || z > 10000) { fprintf(stderr," EXPLORE z=%d %d    in %d*%d, pixel %d, droplet %d  %d\n",
	     z, droplet->pixel[n].z, droplet->pixel[n].x, droplet->pixel[n].y, n, n_droplet, max_droplet); }
	  droplet->sum += z;
     res[i]=0;

     if ( z < trig_level ) return rea;
     if ( x+1 < image.x_size )  rea += explore( x+1, y, droplet);
     if ( y+1 < image.y_size )  rea += explore( x, y+1, droplet);
     if ( x >= 1 )  rea += explore( x-1, y, droplet);
     if ( y >= 1 )  rea += explore( x, y-1, droplet);
     return rea;
     }
/*-----------------------------------------------------------*/
void print_droplet(int z_peak)
{   int  i, j, z_print;
    PIXEL *l_pixel;
    int   *xray;
    DROPLET  *l_droplet;
    z_print = print_map * z_peak;
    for ( i = 0, l_droplet = droplet; i < n_droplet; i++, l_droplet++)
    {    if (print_key>1 || ( print_map && l_droplet->sum >= print_map * z_peak ) )
            fprintf (f_out, "#G %4d  P=%3d  S=%4d  X=%d\n", i, 
                l_droplet->n_pixel, l_droplet->sum, l_droplet->n_xray);
         if ( print_map > 0 && l_droplet->sum >= z_print)
             for ( j=0,l_pixel = l_droplet->pixel; j < l_droplet->n_pixel; j++, l_pixel++)
              fprintf(f_out, "#M  %3d  %3d  %3d\n", l_pixel->x, l_pixel->y, l_pixel->z);
         l_pixel = l_droplet->pixel;
         for ( j=0, xray = l_droplet->xray; j < l_droplet->n_xray; j++, xray++)
               fprintf(f_out, "%3d %3d\n", l_pixel[*xray].x, l_pixel[*xray].y);
         }
    }
/*-----------------------------------------------------------*/
#define RES_HISTO 5
#define HISTO ( 3 * RES_HISTO )
int histogramme( float moy )
{   int   i, j, sum, imax;
    DROPLET  *l_droplet;
    int histo[HISTO];
    float a,b ;

    for (i=0; i<HISTO; i++) histo[i]=0;
	 if ( moy > 100 ) sum = 10 * floor(moy / (RES_HISTO * 10));
	 else if ( moy > 10 ) sum = floor(moy / RES_HISTO);
    else sum = 1;
    if ( sum == 0 ) sum = 1;
       
    for ( i = 0, l_droplet = droplet; i < n_droplet; i++, l_droplet++)
    {   j = l_droplet->sum / sum;
        if (j >= HISTO ) j = HISTO-1;
        histo[j]++;
        }
    if (print_key > 0)
    {   fprintf(f_out, "# histogramme :\n# z");
        for (i=0; i<HISTO; i++) fprintf(f_out, " %4d", i*sum);
        fprintf(f_out, "\n# n   ");
        for (i=0; i<HISTO; i++) fprintf(f_out, " %4d", histo[i]);
        fprintf(f_out, "\n");
        }
        
    imax = 0;
    for (i = 1; i < HISTO; i++)
      if (histo[i] > histo[imax]) imax = i;
    if ( imax !=0 && imax != HISTO-1)
    {   a = histo[imax+1] + histo[imax-1] - 2 * histo[imax];
        b = 0.5 * (histo[imax+1] - histo[imax-1]);
        if ( ( a <=-1 || a>=1 )) 
         imax = ceil(0.5 + sum * ( (imax + 0.5) - b / a));
        else imax = imax * (sum+sum/2);
       }
	 else imax = imax * (sum+sum/2);
	 if (imax <= 0 || imax > sum * HISTO ) imax = sum * RES_HISTO;
    return imax;
    }
/*-----------------------------------------------------------*/
int analyse( int z_peak, int max )
{   int   i, j, k, n, z, t_xray, zmid;
    DROPLET  *l_droplet;
    PIXEL *l_pixel;
    int   *xray;
    int   *nx;
    
    /* rejet eventuels des cosmiques ... */
    if (z_cosmic != 0)
    {   int  tcosmic, zcosmic;
        tcosmic = 0;
        zcosmic = (z_cosmic * z_peak);
        for ( i = 0, l_droplet = droplet; i < n_droplet; i++, l_droplet++)
        {   l_pixel = l_droplet->pixel;
            for ( j=0; j < l_droplet->n_pixel; j++, l_pixel++)
            if (l_pixel->z > zcosmic)
            {   l_droplet->sum -= l_pixel->z;
                if (print_key >= 1) fprintf(f_out, "#Q %d %d %d\n", l_pixel->x, l_pixel->y, l_pixel->z );
	             l_pixel->z = 0;
                tcosmic++;
		          }
            }
        printf(" %d cosmic pixels removed with z > %d = (%d * %.1f)\n", tcosmic, zcosmic, z_peak, z_cosmic);
        if (print_key > 0) fprintf(f_out, "#R %d cosmic pixels removed with z > %d = (%d * %.1f)\n", tcosmic, zcosmic, z_peak, z_cosmic);
	}
    max = 2 + max / z_peak;
    nx = (int *) malloc(max * sizeof(int));
    if ( nx == NULL )
      v_error(__FILE__, " pb alloc nx %d\n", max*sizeof(int));
    memset(nx, 0, max * sizeof(int));
    t_xray = 0;
    zmid = z_peak * (1-z_trig);
    /* calcul du nb de photons */
    for ( i = 0, l_droplet = droplet; i < n_droplet; i++, l_droplet++)
    {   t_xray += l_droplet->n_xray = n = ( zmid + l_droplet->sum ) / z_peak ;
if (n<0 || n>100) fprintf(stderr," DROPPLET %d N XRAY %d   ( zmid %d + l_droplet->sum %d ) / z_peak %d \n", 
          i, n, zmid, l_droplet->sum , z_peak); 
        nx[n]++;
        if (n == 0) continue;
	     xray = l_droplet->xray = (int *) malloc(n*sizeof(int));
        if ( xray == NULL )
          v_error(__FILE__, " pb alloc xray %d,  l_droplet->sum %d\n", n*sizeof(int), l_droplet->sum);
        while ( n-- > 0 )
        {   l_pixel = l_droplet->pixel;
            k = 0;
            z = l_pixel->z;
            for ( j=1, l_pixel++; j < l_droplet->n_pixel; j++, l_pixel++)
              if (l_pixel->z > z)
              {   k = j;
                  z = l_pixel->z;
                  }
            *xray = k;
            l_droplet->pixel[k].z -= z_peak;
            xray++;
            }
        for (n=0, xray = l_droplet->xray; n < l_droplet->n_xray; n++, xray++) 
           l_droplet->pixel[*xray].z += z_peak;
        }
    if (print_key > 0) 
    {  if ( max < 30 )
       {   for (i = 0; i < max; i++ )
           fprintf(f_out, "%sn[%d]=%d ", (i%10)==0?"\n# ":" ", i, nx[i]);
           fprintf(f_out, "\n");
           }
       else       
       {   for (i = 0, j = 0; i < max; i++ ) 
           if (nx[i] ) fprintf(f_out, "%sn[%d]=%d ", (j++%10)==0?"\n# ":" ", i, nx[i]);
           fprintf(f_out, "\n");
           }
       }    
    free(nx);
    return t_xray;
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
